package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Calendar;

import com.delfines.dao.ConnectionFactoryGosocket;

import vo.DateUtil;

public class GosocketBo {
	
	public void insertarInvoice(String fileName,String nroComprobante,String fechaComprobante,String tipoComprobante,String tipoMoneda,String montoPagar){
		PreparedStatement ps=null;
        try {
        	
        	Connection conn = ConnectionFactoryGosocket.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
	        query.append("INSERT INTO dbo.invoice(file_name,nro_comprobante,fecha_comprobante,tipo_comprobante,tipo_moneda,monto_pagar,audit_fechahora)VALUES(?,?,?,?,?,?,getdate()) ");
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fileName);
            ps.setString(2, nroComprobante);
            ps.setString(3, fechaComprobante);
            ps.setString(4, tipoComprobante);
            ps.setString(5, tipoMoneda);
            ps.setString(6, montoPagar);
            
            Integer ins=ps.executeUpdate();
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public void deleteInvoice(String fecha)throws Exception{
		PreparedStatement ps=null;
        try {
        	Connection conn = ConnectionFactoryGosocket.getInstance().getConnection();
        	StringBuilder query = new StringBuilder();
            query.append("DELETE FROM dbo.invoice WHERE ltrim(rtrim(fecha_comprobante))=? ");
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            ps.executeUpdate();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
        }
    }
	
	public String getDAYd1(){
		String n=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryGosocket.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT RIGHT(CONCAT('00', DAY(GETDATE()-1)),2) n ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	n=rs.getString("n");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return n;
	}
	
	public String getMONTHd1(){
		String n=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryGosocket.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT RIGHT(CONCAT('00', MONTH(GETDATE()-1)),2) n ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	n=rs.getString("n");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return n;
	}
	
	public String getYEARd1(){
		String n=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryGosocket.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT YEAR(GETDATE()-1) n ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	n=rs.getString("n");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return n;
	}
	
	/*
	 * TODAY
	 */
	public String getDAY(){
		String n=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryGosocket.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT RIGHT(CONCAT('00', DAY(GETDATE())),2) n ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	n=rs.getString("n");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return n;
	}
	
	public String getMONTH(){
		String n=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryGosocket.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT RIGHT(CONCAT('00', MONTH(GETDATE())),2) n ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	n=rs.getString("n");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return n;
	}
	
	public String getYEAR(){
		String n=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryGosocket.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT YEAR(GETDATE()-1) n ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	n=rs.getString("n");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return n;
	}
	
}

