package com.delfines.business;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import com.delfines.dao.ConnectionFactory;
import com.delfines.dao.ConnectionFactoryOpera;
import com.delfines.vo.Arrival;
import com.delfines.vo.Invoice;

public class RecepcionBo {
	
	public List<Invoice> listArrivals(String fecha){
		List<Invoice> lista = new ArrayList<Invoice>(); 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactory.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select id_invoice,file_name,nro_comprobante,convert(varchar, CONVERT(DATE, fecha_comprobante, 102), 103) fecha_comprobante,(case tipo_comprobante when '01' then 'FACTURA' when '03' then 'BOLETA' else 'OTRO' end) tipo_comprobante,tipo_moneda,monto_pagar from dbo.invoice where tipo_comprobante='01' and convert(varchar, CONVERT(DATE, fecha_comprobante, 102), 103)=? order by nro_comprobante desc");
            
            ps = conn.prepareStatement(query.toString());
            ps.setString(1, fecha);
            
            rs = ps.executeQuery();
            
            while(rs.next()){
            	Invoice att=new Invoice();
    			att.setIdInvoice(rs.getInt("id_invoice"));
    			att.setFileName(rs.getString("file_name"));
    			att.setNroComprobante(rs.getString("nro_comprobante"));
    			att.setFechaComprobante(rs.getString("fecha_comprobante"));
    			att.setTipoComprobante(rs.getString("tipo_comprobante"));
    			att.setTipoMoneda(rs.getString("tipo_moneda"));
    			att.setMontoPagar(rs.getString("monto_pagar"));
    			lista.add(att);
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return lista;
	}
	
	
	public String getDate(){
		String fecha=null; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT TO_CHAR(SYSDATE-1,'DD/MM/RRRR') FECHA FROM DUAL");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	fecha=rs.getString("FECHA");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return fecha;
	}
	
	public String getDateXML(){
		String fecha=null; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;
        try {
        	Connection conn = ConnectionFactoryOpera.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT TO_CHAR(SYSDATE,'RRRR-MM-DD') FECHA FROM DUAL");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	fecha=rs.getString("FECHA");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return fecha;
	}
	
}

