package com.delfines.spring.controller;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.commons.io.IOUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.business.RecepcionBo;
import com.delfines.vo.Arrival;
import com.delfines.vo.Invoice;
import com.delfines.vo.Usuario;

/**
 * @author imssbora
 */
@Controller
public class ArrivalsController {
   
	@Autowired
    private HttpServletRequest request;
	
	//buscador
	@RequestMapping(path={"/arrivals"},method=RequestMethod.GET)
	public String registroPago(Model model,HttpServletRequest request) {
		RecepcionBo bo=new RecepcionBo();  
 	    String fechaHoy=bo.getDate();
 	    model.addAttribute("fechaHoy", fechaHoy);
 	   
        return "arrivals";   
	}
	
	//listar facturas
	@RequestMapping(path={"/lista-arrivals"},method=RequestMethod.GET)
    public ModelAndView reporteLeads(String fechaArrival,Model model,HttpServletRequest request) {
	   List<Invoice> lista = new ArrayList<Invoice>();
	   RecepcionBo bo=new RecepcionBo();
	   
	   lista = bo.listArrivals(fechaArrival);
	   
	   request.getSession().setAttribute("fechaArrival", fechaArrival);
	   
	   ModelAndView mv = new ModelAndView("/arrivals-tabla");
	   mv.addObject("lista",lista);
	   return mv;
    }
	
	@RequestMapping(value={"/reenvia-gosocket"},method=RequestMethod.GET)
	@ResponseBody
    public String reenviaGosocket(String fileName,Model model,HttpServletRequest request) {
	   RecepcionBo bo=new RecepcionBo();  
	   String fechaHoy=bo.getDate();
	   String fechaHoyXML=bo.getDateXML();
	   model.addAttribute("fechaHoy", fechaHoy);
	   
	    String fileFrom = CorrectToUBL21SUNAT.xmlPathFrom+fileName;
   		String fileTo = CorrectToUBL21SUNAT.xmlPathTo+fileName.replaceAll(" ","-").replaceAll(".xml", "OK.xml");
   	
   		CorrectToUBL21SUNAT t =new CorrectToUBL21SUNAT();
   		t.convert(fileFrom,fileTo,fechaHoyXML);
   		
   		return "1";
    }
	
	
}